<template>
    <v-row>
        <v-col>
            <warehouse-form
                v-model="warehouse"
                :loading="loading"
                :clearable="false"
                @updated="onUpdate"
                mode="edit"
            >
            </warehouse-form>
        </v-col>
    </v-row>
</template>

<script>
    import WarehouseForm from "./WarehouseForm";
    import util from "../../../mixins/util";

    export default {
        name: "WarehouseEdit",
        components: {WarehouseForm},
        mixins: [ util ],
        props: {
            id: [String, Number],
        },
        data: () => ({
            loading: true,
            warehouse: {
                id: 0,
                name: '',
                country: '',
                slug: '',
                address1: '',
                address2: '',
                city: '',
                phone: '',
                fax: '',
                default: 1,
                enabled: 1
            },
        }),

        mounted() {
            this.fetchWarehouse()
                .then(data => {
                    this.mapWarehouse(data);
                    this.loading = false;
                })
        },

        methods: {
            fetchWarehouse() {
                return new Promise((resolve, reject) => {
                    axios.get(`api/warehouses/${this.id}`)
                        .then(({ data }) => {
                            resolve(data);
                        })
                        .catch(error => {
                            reject(error);
                        })
                })
            },

            mapWarehouse(warehouse) {
                this.warehouse.id = warehouse.id;
                this.warehouse.name = warehouse.name;
                this.warehouse.slug = warehouse.slug;
                this.warehouse.country = warehouse.country;
                this.warehouse.address1 = warehouse.address1;
                this.warehouse.address2 = warehouse.address2;
                this.warehouse.city = warehouse.city;
                this.warehouse.phone = warehouse.phone;
                this.warehouse.fax = warehouse.fax;
                this.warehouse.default = warehouse.default ? 1 : 0;
                this.warehouse.enabled = warehouse.enabled ? 1 : 0;
            },

            onUpdate(warehouse) {
                this.mapWarehouse(warehouse);
            }
        }
    }
</script>

<style >

</style>
